<?php
/*
Plugin Name: Cookie Control
Plugin URI: http://www.civicuk.com/cookie-law/index
Description: Cookie Control is a mechanism for controlling user consent for the use of cookies on their computer.
Version: 3.2
Author: Civic UK
Author URI: http://civicuk.com/cookie-law/index
*/

//  defaults
$def_cookiecontrol_consentmodel = 'INFO';
$def_cookiecontrol_alwaysShow = 'false';
$def_cookiecontrol_preserveConsentOnHide = 'false';

$def_cookiecontrol_popup = 'true';
$def_cookiecontrol_timeout = '7';

$def_cookiecontrol_position = 'LEFT';
$def_cookiecontrol_shape = 'TRIANGLE';
$def_cookiecontrol_theme = 'LIGHT';


$def_cookiecontrol_brandingColor = '#f39321';
$def_cookiecontrol_buttonsColor = '#32796D';
$def_cookiecontrol_buttonsHoverColor = '#32796D';
$def_cookiecontrol_linksColor = '#454545';
$def_cookiecontrol_textColor = '#444';
$def_cookiecontrol_barColor = '#fff';

$def_cookiecontrol_barHeight = '50';
$def_cookiecontrol_toggleWidth = '';

$def_cookiecontrol_toggleOnBar = 'false';
$def_cookiecontrol_fullTextOnlyOnPopup = 'false';

$def_cookiecontrol_titleText = 'This site uses cookies to store information on your computer.';
$def_cookiecontrol_introText = 'Some of these cookies are essential to make our site work and others help us to improve by giving us some insight into how the site is being used.';
$def_cookiecontrol_fullText = 'These cookies are set when you submit a form, login or interact with the site by doing something that goes beyond clicking some simple links. We also use some non-essential cookies to anonymously track visitors or enhance your experience of this site.';
$def_cookiecontrol_privacyURL = '';

$def_cookiecontrol_countries = 'United Kingdom';
$def_cookiecontrol_protected = '';
$def_cookiecontrol_subdomains = 'true';
$def_cookiecontrol_branding = 'true';

$def_cookiecontrol_gakey = '';
$def_cookiecontrol_analytics = '';

$def_cookiecontrol_ias = 'Information and Settings';
$def_cookiecontrol_on = 'Turn cookies on';
$def_cookiecontrol_off = 'Turn cookies off';
$def_cookiecontrol_bs = 'Browser Settings';
$def_cookiecontrol_rm = 'Read more';
$def_cookiecontrol_rl = 'Read less';
$def_cookiecontrol_ab = 'About this tool';
$def_cookiecontrol_c = 'I\'m fine with this';

$def_cookiecontrol_onlyHideIfConsented = 'false';

$def_cookiecontrol_l = '';
$def_cookiecontrol_c_consent = '';
$def_cookiecontrol_c_consent_model = '';
$def_cookiecontrol_translations = '';

// define defaults
$cookiecontrol_defaults = apply_filters('cookiecontrol_defaults', array(
    'consentmodel' => $def_cookiecontrol_consentmodel,
    'onlyHideIfConsented' => $def_cookiecontrol_onlyHideIfConsented,
    'alwaysShow' => $def_cookiecontrol_alwaysShow,

    'popup' => $def_cookiecontrol_popup,
    'timeout' => $def_cookiecontrol_timeout,

    'position' => $def_cookiecontrol_position,
    'shape' => $def_cookiecontrol_shape,
    'theme' => $def_cookiecontrol_theme,
    'brandingColor' => $def_cookiecontrol_brandingColor,
    'buttonsColor' => $def_cookiecontrol_buttonsColor,
    'buttonsHoverColor' => $def_cookiecontrol_buttonsHoverColor,
    'linksColor' => $def_cookiecontrol_linksColor,
    'textColor' => $def_cookiecontrol_textColor,
    'barColor' => $def_cookiecontrol_barColor,
    'barHeight' => $def_cookiecontrol_barHeight,
    'toggleWidth' => $def_cookiecontrol_toggleWidth,

    'toggleOnBar' => $def_cookiecontrol_toggleOnBar,
    'fullTextOnlyOnPopup' => $def_cookiecontrol_fullTextOnlyOnPopup,

    'titleText' => $def_cookiecontrol_titleText,
    'introText' => $def_cookiecontrol_introText,
    'fullText' => $def_cookiecontrol_fullText,
    'privacyURL' => $def_cookiecontrol_privacyURL,

    'countries' => $def_cookiecontrol_countries,
    'protected' => $def_cookiecontrol_protected,
    'subdomains' => $def_cookiecontrol_subdomains,
    'branding' => $def_cookiecontrol_branding,
	
    'gakey' => $def_cookiecontrol_gakey,
    'analytics' => $def_cookiecontrol_analytics,

    'ias' => $def_cookiecontrol_ias,
    'on' => $def_cookiecontrol_on,
    'off' => $def_cookiecontrol_off,
    'bs' => $def_cookiecontrol_bs,
    'rm' => $def_cookiecontrol_rm,
    'rl' => $def_cookiecontrol_rl,
    'ab' => $def_cookiecontrol_ab,
    'c' => $def_cookiecontrol_c,

    'languageCode' => $def_cookiecontrol_l,
    'countryConsentModel' => $def_cookiecontrol_c_consent_model,
    'countryConsent' => $def_cookiecontrol_c_consent,
    'translations' => $def_cookiecontrol_translations,
    'preserveConsentOnHide' => $def_cookiecontrol_preserveConsentOnHide,

));

// pull the settings from the db
$cookiecontrol_settings = get_option('cookiecontrol_settings');
// fallback default settings
$cookiecontrol_settings = wp_parse_args($cookiecontrol_settings, $cookiecontrol_defaults);

// registers settings in the db
add_action('admin_init', 'cookiecontrol_register_settings');
function cookiecontrol_register_settings() {
    register_setting('cookiecontrol_settings', 'cookiecontrol_settings', 'cookiecontrol_settings_validate');
}

//	this function adds the settings page to the Appearance tab
add_action('admin_menu', 'add_cookiecontrol_menu');
function add_cookiecontrol_menu() {
    add_menu_page('Cookie Control', 'Cookie Control', 'administrator', 'cookiecontrol', 'cookiecontrol_admin_page');
}

// options page styling
function custom_admin_styles() {
    wp_register_style( 'style.css', site_url().'/wp-content/plugins/cookie-control/css/style.css', null, '1.0', 'screen' );
    wp_enqueue_style( 'style.css' );
}

add_action( 'admin_print_styles', 'custom_admin_styles' );

function custom_admin_scripts($hook) { 
    if ( $hook == 'toplevel_page_cookiecontrol'){
      wp_enqueue_script('jquery-ui-tabs');
      wp_enqueue_script( 'script', site_url().'/wp-content/plugins/cookie-control/js/script.js' );
    }        
}
add_action( 'admin_enqueue_scripts', 'custom_admin_scripts' );

//Settings page
function cookiecontrol_admin_page() { 
?>

<div class="ccc-container">

<header>
    <h1>
	<a href="http://www.civicuk.com/cookie-law/index" title="Cookie Control by Civic" target="_blank">Cookie Control by Civic</a>
    </h1>
</header>

<hr>

<div>
<p>With an elegant  user-interface that doesn't hurt the look and feel of your site, Cookie Control is a mechanism for controlling user consent for the use of cookies on their computer.</p>
<p>For more information, please visit Civic's Cookie Control pages at: <a href="http://www.civicuk.com/cookie-law/index" title="Cookie Control by Civic" target="_blank">http://www.civicuk.com/cookie-law/index</a></p>
<a class="civic" href="http://www.civicuk.com/cookie-law/pricing" target="_blank">Get Your API Key</a>
</div>

<div class="wrap">
<?php cookiecontrol_settings_update_check(); ?>
<form method="post" action="options.php">
<?php settings_fields('cookiecontrol_settings'); ?>
<?php global $cookiecontrol_settings; $options = $cookiecontrol_settings;?>
	
    <!-- API -->
    <h2>Your Cookie Control Product Information</h2>
    <table class="form-table">
      <tr>
        <th scope="row">
          <label for="cookiecontrol_settings[apikey]">API Key <span>&#42;</span></label>
        </th>
        <td>
          <input type="text" name="cookiecontrol_settings[apiKey]" id="cookiecontrol_settings[apiKey]" value="<?php echo ( isset($options['apiKey']) ? $options['apiKey'] : '' ); ?>" size="50" />
        </td>
      </tr>
      <tr>
        <th scope="row">
          <label for="cookiecontrol_settings[product]">Product License Type <span>&#42;</span></label>
        </th>
        <td>
          <input type="radio" class="first" name="cookiecontrol_settings[product]" id="cookiecontrol_settings[product]" value="PROD_FREE" <?php checked('PROD_FREE', ( isset($options['product']) ? $options['product'] : '' )); ?> />Free
          <input type="radio" name="cookiecontrol_settings[product]" id="cookiecontrol_settings[product]" value="PROD_PAID" <?php checked('PROD_PAID', ( isset($options['product']) ? $options['product'] : '' )); ?> />Single Domain
          <input type="radio" name="cookiecontrol_settings[product]" id="cookiecontrol_settings[product]" value="PROD_PAID_MULTISITE" <?php checked('PROD_PAID_MULTISITE', ( isset($options['product']) ? $options['product'] : ' ' )); ?> />Multi Domain
          <input type="radio" name="cookiecontrol_settings[product]" id="cookiecontrol_settings[product]" value="PROD_PAID_CUSTOM" <?php checked('PROD_PAID_CUSTOM', ( isset($options['product']) ? $options['product'] : '' )); ?> />Custom
        </td>
      </tr>
    </table>
	
    <hr />

  <div id="cookie-tabs">
    <ul>
      <li><h3><a href="#consent">Consent Model</a></h3></li>
      <li><h3><a href="#pop_up">Pop up</a></h4></li>
      <li><h3><a href="#look_feel">Look & Feel</a></h3></li>
      <li><h3><a href="#text">Text</a></h3></li>
      <li><h3><a href="#extra">Extra</a></h3></li>
      <li><h3><a href="#analytics">Analytics</a></h3></li>
      <li><h3><a href="#regional">Regional</a></h3></li>
    </ul>

    <div id="consent">
      <!-- CONSENT MODEL - H3 radio options, information_only, implicit, explicit. implicit default. need good explanation for each option -->
      <h2>Choose your compliance model</h2>
      <p>Select the default consent model you wish Cookie Control to use. In each consent model the Cookie Control panel appears to the user when they first access the site.</p>
      <table class="form-table">
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[consentmodel]">Compliance Model</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[consentmodel]" value="INFO" <?php checked('INFO', $options['consentmodel']); ?> />Information Only
            <input type="radio" name="cookiecontrol_settings[consentmodel]" value="IMPLICIT" <?php checked('IMPLICIT', $options['consentmodel']); ?> />Implied Consent
            <input type="radio" name="cookiecontrol_settings[consentmodel]" value="EXPLICIT" <?php checked('EXPLICIT', $options['consentmodel']); ?> />Explicit Consent
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[preserveConsentOnHide]">Preserve consent on hide</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[preserveConsentOnHide]" id="cookiecontrol_settings[preserveConsentOnHide]" value="true" <?php checked('true', $options['preserveConsentOnHide']); ?> />Yes
            <input type="radio" name="cookiecontrol_settings[preserveConsentOnHide]" id="cookiecontrol_settings[preserveConsentOnHide]" value="false" <?php checked('false', $options['preserveConsentOnHide']); ?> />No
          </td>
        </tr>				
      </table>
      <br />          
      <!-- END COSENT MODEL -->
      <hr />
    </div>

    <div id="pop_up">
      <p>Select the behaviour of the ‘X’ button (for corner pop-up widgets) and ‘Close’ button (for bar widgets). Normally, pressing these buttons will hide the widget and not show it again on the next page load. Set this option to true to keep showing the widget until the user provides (or explicitly denies) consent.</p>
      <table class="form-table">
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[onlyHideIfConsented]">Close Behaviour</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[onlyHideIfConsented]" id="cookiecontrol_settings[onlyHideIfConsented]" value="true" <?php checked('true', $options['onlyHideIfConsented']); ?> />True - Keep showing the widget
            <input type="radio" name="cookiecontrol_settings[onlyHideIfConsented]" id="cookiecontrol_settings[onlyHideIfConsented]" value="false" <?php checked('false', $options['onlyHideIfConsented']); ?> />False - Hide the widget on close
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[alwaysShow]">Always Show</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[alwaysShow]" id="cookiecontrol_settings[alwaysShow]" value="true" <?php checked('true', $options['alwaysShow']); ?> />True - The icon for toggling Cookie Control widget on or off will always be available.
            <input type="radio" name="cookiecontrol_settings[alwaysShow]" id="cookiecontrol_settings[alwaysShow]" value="false" <?php checked('false', $options['alwaysShow']); ?> />False - Hide the widget on close
          </td>
        </tr>	
      </table>
      <br>
      <!-- Pop Up -->
      <h2>Pop up by default</h2>
      <p>Choose whether the Cookie Control user interface (UI) is open by default on page load. This makes it much more explicit that you're seeking user's consent for the use of cookies and may be a safer option in terms of compliance.</p>
      <table class="form-table">
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[popup]">Pop up by default</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[popup]" id="cookiecontrol_settings[popup]" value="true" <?php checked('true', $options['popup']); ?> />Yes
            <input type="radio" name="cookiecontrol_settings[popup]" id="cookiecontrol_settings[popup]" value="false" <?php checked('false', $options['popup']); ?> />No
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[timeout]">Pop up Timeout</label></th>
          <td>
            <input type="text" name="cookiecontrol_settings[timeout]" id="cookiecontrol_settings[timeout]" value="<?php echo $options['timeout'] ?>" size="1" /> seconds
          </td>
        </tr>
      </table>
      <br>
      <!-- End Pop Up -->
      <hr />
      <!-- Full text only on Popup -->
      <h2>Full text only on Popup</h2>
      <p>By default, on the bar interface, the "Information and Settings" popup will contain some introductory text, concatenated with the title, that appears on the bar. Setting this to true will only show the full text on that popup. This is the text you specify using the full property of the t object. The option is only available for Cookie Control premium.</p>
      <table class="form-table">
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[fullTextOnlyOnPopup]">Full text only on Popup</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[fullTextOnlyOnPopup]" id="cookiecontrol_settings[fullTextOnlyOnPopup]" value="true" <?php checked('true', $options['fullTextOnlyOnPopup']); ?> />Yes
            <input type="radio" name="cookiecontrol_settings[fullTextOnlyOnPopup]" id="cookiecontrol_settings[fullTextOnlyOnPopup]" value="false" <?php checked('false', $options['fullTextOnlyOnPopup']); ?> />No
          </td>
        </tr>
      </table>  
      <br />

      <hr />
    </div>

    <div id="look_feel">
      <!-- Look and Feel -->
      <h2>Look and Feel</h2>
      <p>Choose your widget style, position, theme and background.</p>
      <p>Note that a <b>license</b> is required for the top bar and bottom bar versions of the interface and the color selection.</p>
      <table class="form-table">
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[shape]">Widget Style</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[shape]" id="cookiecontrol_settings[shape]" value="TRIANGLE" <?php checked('TRIANGLE', $options['shape']); ?> />Triangle
            <input type="radio" name="cookiecontrol_settings[shape]" id="cookiecontrol_settings[shape]" value="SQUARE" <?php checked('SQUARE', $options['shape']); ?> />Square
            <input type="radio" name="cookiecontrol_settings[shape]" id="cookiecontrol_settings[shape]" value="DIAMOND" <?php checked('DIAMOND', $options['shape']); ?> />Diamond
            <input type="radio" name="cookiecontrol_settings[shape]" id="cookiecontrol_settings[shape]" value="BAR" <?php checked('BAR', $options['shape']); ?> />Bar
          </td>
        </tr>	
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[position]">Widget Position</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[position]" id="cookiecontrol_settings[position]" value="LEFT" <?php checked('LEFT', $options['position']); ?> />Left
            <input type="radio" name="cookiecontrol_settings[position]" id="cookiecontrol_settings[position]" value="RIGHT" <?php checked('RIGHT', $options['position']); ?> />Right
            <input type="radio" name="cookiecontrol_settings[position]" id="cookiecontrol_settings[position]" value="TOP" <?php checked('TOP', $options['position']); ?> />Top
            <input type="radio" name="cookiecontrol_settings[position]" id="cookiecontrol_settings[position]" value="BOTTOM" <?php checked('BOTTOM', $options['position']); ?> />Bottom
          </td>
        </tr>	
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[theme]">Widget Theme</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[theme]" id="cookiecontrol_settings[theme]" value="LIGHT" <?php checked('LIGHT', $options['theme']); ?> />Light
            <input type="radio" name="cookiecontrol_settings[theme]" id="cookiecontrol_settings[theme]" value="DARK" <?php checked('DARK', $options['theme']); ?> />Dark
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[brandingColor]">Branding Color</label>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[brandingColor]" id="cookiecontrol_settings[brandingColor]" value="<?php echo ( ($options['brandingColor']!= '') ? $options['brandingColor'] : '#f39321' ); ?>" size="8" />
          </td>
        </tr>	
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[buttonsColor]">Buttons Color</label>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[buttonsColor]" id="cookiecontrol_settings[buttonsColor]" value="<?php echo ( ($options['buttonsColor'] != '') ? $options['buttonsColor'] : '#32796D' ); ?>" size="8" />
          </td>
        </tr>	
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[buttonsHoverColor]">Buttons Hover Color</label>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[buttonsHoverColor]" id="cookiecontrol_settings[buttonsHoverColor]" value="<?php echo ( ($options['buttonsHoverColor'] != '') ? $options['buttonsHoverColor'] : '#32796D' ); ?>" size="8" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[textColor]">Text Color</label>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[textColor]" id="cookiecontrol_settings[textColor]" value="<?php echo ( ($options['textColor'] != '' ) ? $options['textColor'] : '#444' ); ?>" size="8" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[linksColor]">Links Color</label>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[linksColor]" id="cookiecontrol_settings[linksColor]" value="<?php echo ( ($options['linksColor'] != '' ) ? $options['linksColor'] : '#454545' ); ?>" size="8" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[barColor]">Bar Color</label>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[barColor]" id="cookiecontrol_settings[barColor]" value="<?php echo ( ($options['barColor'] != '' ) ? $options['barColor'] : '#fff' ); ?>" size="8" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[barHeight]">Bar Height</label>
            <div><span>The height of the bar in pixels, as a number. By default the height of the bar is 50px.</span></div>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[barHeight]" id="cookiecontrol_settings[barHeight]" value="<?php echo ( ($options['barHeight'] != '' ) ? $options['barHeight'] : '50' ); ?>" size="8" />
          </td>            
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[toggleWidth]">Toggle buttons width</label>
            <div><span>When toggleOnBar is set, you can use this option to control the width of the toggle button. It will be ignored when toggleOnBar is not set. If it is not specified the width of toggle button will be the same as the one of the close button.</span></div>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[toggleWidth]" id="cookiecontrol_settings[toggleWidth]" value="<?php echo ( ($options['toggleWidth'] != '' ) ? $options['toggleWidth'] : '' ); ?>" size="8" />
          </td>            
        </tr>
      </table>
      <br />
      <hr />
      <!-- Toggle on bar interface -->
      <h2>Toggle on bar interface</h2>
      <p>By default, on the bar interface, the button that allows the user to turn cookies on or off is in the "Information and Settings" popup. Setting this to true will put it on the bar itself, next to the button that closes the widget. The option is only available for Cookie Control premium.</p>
      <table class="form-table">
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[toggleOnBar]">Toggle on Bar</label>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[toggleOnBar]" id="cookiecontrol_settings[toggleOnBar]" value="true" <?php checked('true', $options['toggleOnBar']); ?> />Yes
            <input type="radio" name="cookiecontrol_settings[toggleOnBar]" id="cookiecontrol_settings[toggleOnBar]" value="false" <?php checked('false', $options['toggleOnBar']); ?> />No
          </td>
        </tr>
      </table>  
      <br />
      <hr />
    </div>

    <div id="text">
      <!--Text Options-->
      <h2>Text Options</h2>
      <table class="form-table">
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[titleText]">Title Text</label>
            <p>On window-style widgets, this text appears as the first sentence of the window. On bar-style widgets, this is the only text visible on the bar before it is expanded.</p>
          </th>
          <td>
            <textarea name="cookiecontrol_settings[titleText]" id="cookiecontrol_settings[titleText]" cols="100" rows="5"><?php echo $options['titleText'] ?></textarea>
          </td>
        </tr>
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[introText]">Introductory Text</label>
            <p>Some short, sharp copy to introduce the role of cookies on your site. On window-style widgets, this text is concatenated to the title and appears together. On bar-style widgets, this is the first text displayed in the widget when the information panel is visible.</p>
            </th>
            <td>
              <textarea name="cookiecontrol_settings[introText]" id="cookiecontrol_settings[introText]" cols="100" rows="5"><?php echo $options['introText'] ?></textarea>
            </td>
        </tr>
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[fullText]">Additional Text</label>
            <p>Describe in general terms what your cookies are used for.</p>
          </th>
          <td>
            <textarea name="cookiecontrol_settings[fullText]" id="cookiecontrol_settings[fullText]" cols="100" rows="5"><?php echo $options['fullText'] ?></textarea>
          </td>
        </tr>
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[privacyURL]">Privacy or cookie policy</label>
            <p>A privacy policy explaining how you manage personal data, and how cookies are used on your site is essential for legal compliance. Please provide the full URL to your privacy or cookie policy.</p>
            <p style="color: orange; font-weight: 700;">Please note this link is added at the end of your additional text.</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[privacyURL]" id="cookiecontrol_settings[privacyURL]" value="<?php echo $options['privacyURL'] ?>" size="50" />
          </td>
        </tr>
      </table>
      <br />

      <hr />
    </div>
  
    <div id="extra">
      <!-- Techinal Functionality -->
      <h2>Additional Functionality</h2>
      <table class="form-table">	
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[countries]">Countries to show Cookie Control</label>
            <p>Please enter a comma separated list of countries for which you wish the plugin to appear. If left blank Cookie Control will appear for all users from all countries. View the full <a target="_blank" href="http://www.iso.org/iso/country_codes/iso_3166_code_lists/country_names_and_code_elements.htm">list of countries.</a></p>
            <p>Please note this feature is available to paid versions only.</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[countries]" id="cookiecontrol_settings[countries]" value="<?php echo $options['countries'] ?>" size="50" />
          </td>
        </tr>	
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[protected]">List of Protected Cookies</label>
            <p>Please enter a comma separated list of the cookies you do not want deleted.</p>
            <p>For example 'analytics', 'twitter', etc.</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[protected]" id="cookiecontrol_settings[protected]" value="<?php echo $options['protected'] ?>" size="50" />
          </td>
        </tr>		
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[subdomains]">Delete cookies on subdomains too</label>
            <p>If set to true (the default), Cookie Control assumes it is deployed on a subdomain. Deleting cookies will attempt to delete them for the subdomain, but also try all super-domains.</p>
            <p>This options enables you to clear cookies from subdomains. It does NOT enable Cookie Control to work in subdomains. If this is what you require then you might be interested in our multi domain licence.</p>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[subdomains]" id="cookiecontrol_settings[subdomains]" value="true" <?php checked('true', $options['subdomains']); ?> /> Yes
            <input type="radio" name="cookiecontrol_settings[subdomains]" id="cookiecontrol_settings[subdomains]" value="false" <?php checked('false', $options['subdomains']); ?> /> No
          </td>
        </tr>	
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[branding]">Branding</label>
            <p>If set to No (false) the widget appears without the Cookie Control logo and text as part of the widget's header.</p>
            <p>About this tool is also removed from the widget's footer.</p>
            <p>Note that a <b>license</b> is required for branding removal.</p>
          </th>
          <td>
            <input type="radio" class="first" name="cookiecontrol_settings[branding]" id="cookiecontrol_settings[branding]" value="true" <?php checked('true', $options['branding']); ?> /> Yes
            <input type="radio" name="cookiecontrol_settings[branding]" id="cookiecontrol_settings[branding]" value="false" <?php checked('false', $options['branding']); ?> /> No
          </td>
        </tr>
      </table>
      <input type="hidden" name="cookiecontrol_settings[update]" value="UPDATED" />
      <br />

      <hr />
    </div>
  
    <div id="analytics">
      <!-- Google Analytics -->
      <h2>Analytics</h2>
      <table class="form-table">
        <tr valign="top">
          <th scope="row">
            <label for="cookiecontrol_settings[analytics]">Analytics Tracking</label>
            <p>If you use Google Analytics, Universal Analytics, or any other Analytics tool, please copy and paste the snippet of code below. This will cause Cookie Control to interact with the Analytics tool, opting users in or out depending on their preference.</p>
            <p style="color: orange; font-weight: 700;">Please note, you do not need to include the &lt;script&gt; tags as part of your input.</p>
          </th>
             <td>
              <textarea name="cookiecontrol_settings[analytics]" id="cookiecontrol_settings[analytics]" cols="100" rows="10"><?php echo $options['analytics'] ?></textarea>
          </td>
        </tr>
      </table>
      <br>

      <hr />
    </div>
  
    <div id="regional">
      <!--Language Options-->
      <h2>Language Options</h2>
      <p>Additional Language settings for all of the text used in Cookie Control.</p>
      <table class="form-table">
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[ias]">Information and Settings Text</label>
            <p>Used to decorate buttons to expand the widget, providing more information. Defaults to "Information and Settings".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[ias]" id="cookiecontrol_settings[ias]" value="<?php echo $options['ias'] ?>" size="50" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[on]">Enable Cookies Text</label>
            <p>This is the text that appears in buttons to enable cookies. It defaults to "Turn cookies on".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[on]" id="cookiecontrol_settings[on]" value="<?php echo $options['on'] ?>" size="50" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[off]">Disable Cookies Text</label>
            <p>This is the text that appears in buttons to disable cookies. It defaults to "Turn cookies off".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[off]" id="cookiecontrol_settings[off]" value="<?php echo $options['off'] ?>" size="50" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[bs]">Browser Settings Text</label>
            <p>This is the text that takes the user to a page (on Civic's website) describing how to configure their particular browser's cookie support for privacy. It defaults to "Browser settings".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[bs]" id="cookiecontrol_settings[bs]" value="<?php echo $options['bs'] ?>" size="50" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[rm]">Read More Text</label>
            <p>This appears in buttons and controls prompting the user to read more text by expanding a hidden panel. It defaults to "Read more".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[rm]" id="cookiecontrol_settings[rm]" value="<?php echo $options['rm'] ?>" size="50" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[rl]">Read Less Text</label>
            <p>This appears in buttons and controls allowing the user to contract panels to hide the full text of the widget. It defaults to "Read less".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[rl]" id="cookiecontrol_settings[rl]" value="<?php echo $options['rl'] ?>" size="50" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[ab]">About This Tool Text</label>
            <p>Text used to take the user to the description of Civic Cookie Control on Civic's servers. Defaults to "About this tool".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[ab]" id="cookiecontrol_settings[ab]" value="<?php echo $options['ab'] ?>" size="50" />
          </td>
        </tr>
        <tr>
          <th scope="row">
            <label for="cookiecontrol_settings[c]">Close This Tool Text</label>
            <p>Text used for buttons that close the widget. Defaults to "I'm fine with this".</p>
          </th>
          <td>
            <input type="text" name="cookiecontrol_settings[c]" id="cookiecontrol_settings[c]" value="<?php echo $options['c'] ?>" size="50" />
          </td>
        </tr>
      </table>
      <br />

      <hr />
        
      <!--Consent model per country-->
      <h2>Consent model per country</h2>
      <p><b>Define different consent model per country. If consent model not selected, the default will be applied</b></p>
      <p>Note that a <b>license</b> is require</p>
      <div class="consentModelTemplate">
        <table class="form-table">
          <tr valign="top">
            <th scope="row">
              <label for="cookiecontrol_settings[countryConsentModel]">Country Code</label>	
              <p>Select country with <a target="_blank" href="https://www.iso.org/obp/ui/#search">ISO 3166-1-alpha-2 codes</a> (e.g. <b>GB</b>, <b>DE</b>)</p>				
            </th>
            <td>
              <input placeholder="Country code ex. GB" type="text" name="cookiecontrol_settings[countryConsent]"  id="cookiecontrol_settings[countryConsent]" size="20" />
              <select  name="cookiecontrol_settings[countryConsentModel]" id="cookiecontrol_settings[countryConsentModel]">
                <option value="">Select consent model</option>
                <option value="INFO">Information Only</option>
                <option value="IMPLICIT">Implied Consent</option>
                <option value="EXPLICIT">Explicit Consent</option>
              </select>
              <a href="#" id="removeConsentModel">Remove</a>
            </td>
          </tr>
        </table>		
      </div>
      <button id="addRowConsent"><i class="icon-plus-sign icon-white"></i>Add country</button></br>
      <div id="consentModelContainer">
        <?php 
          if ( !empty( $options['countryConsent'] ) )
            foreach ($options['countryConsent'] as $key => $val ) { $lanConsModel = $options['countryConsentModel'][$key]; ?>
              <?php if ( trim($val) != '') { ?>
                <div class="countryConsent">
                  <table class="form-table">
                    <tr valign="top">
                      <th scope="row">
                        <label for="cookiecontrol_settings[countryConsentModel]">Country Code</label>	
                        <p>Select country with <a target="_blank" href="https://www.iso.org/obp/ui/#search">ISO 3166-1-alpha-2 codes</a> (e.g. <b>GB</b>, <b>DE</b>)</p>				
                      </th>
                      <td>
                        <input placeholder="Country code ex. GB" type="text" name="cookiecontrol_settings[countryConsent][<?php echo $key ?>]"  id="cookiecontrol_settings[countryConsent][<?php echo $key ?>]" value="<?php echo $val ?>" size="20" />
                        <select name="cookiecontrol_settings[countryConsentModel][<?php echo $key ?>]" id="cookiecontrol_settings[countryConsentModel][<?php echo $key ?>]">
                          <option value="">Select consent model</option>
                          <option value="INFO" <?php echo ($lanConsModel == 'INFO' ? 'selected' : ''); ?> >Information Only</option>
                          <option value="IMPLICIT" <?php echo ($lanConsModel == 'IMPLICIT' ? 'selected' : ''); ?> >Implied Consent</option>
                          <option value="EXPLICIT" <?php echo ($lanConsModel == 'EXPLICIT' ? 'selected' : ''); ?> >Explicit Consent</option>
                        </select>
                        <a href="#" id="removeConsentModel">Remove</a>
                        </td>
                      </tr>
                    </table>
                </div>		
              <?php } ?>
            <?php } 
        ?>
        </div>
        <hr />
	
        <!--Text in more Languages-->
        <h2>Text in more Languages</h2>
        <p>Note that a <b>license</b> is require</p>
        <div class="extraLanguageTemplate">
          <table class="form-table">
            <tr valign="top">
              <th scope="row">
                <label for="cookiecontrol_settings[languageCode]">Language Code</label>		
                <p>Add additional translations. View full <a target="_blank" href="https://www.loc.gov/standards/iso639-2/php/code_list.php">list of languages codes.</a></p>				
              </th>
              <td>
                <input placeholder="Language code ex. fr" type="text" name="cookiecontrol_settings[languageCode]"  id="cookiecontrol_settings[languageCode]" size="20" />
                <a href="#" id="removeExtraLanguage">Remove</a>
              </td>
            </tr>
          </table>		
        </div>
        <button id="addRow"><i class="icon-plus-sign icon-white"></i>Add language</button></br>
        <div id="extraLanguageContainer">
          <?php 
            if ( !empty( $options['languageCode'] ) )
                foreach ($options['languageCode'] as $key => $val ) {  ?>
                    <?php if ( trim($val) != '') { ?>
                        <div class="extraLanguage">
                            <table class="form-table">
                                <tr valign="top">
                                    <th scope="row">
                                        <label for="cookiecontrol_settings[languageCode][<?php echo $key ?>]">Language Code</label>		
                                        <p>Add additional translations. View full <a target="_blank" href="https://www.loc.gov/standards/iso639-2/php/code_list.php">list of languages codes.</a></p>				
                                        </th>
                                    <td>
                                        <input placeholder="Language code" type="text" name="cookiecontrol_settings[languageCode][<?php echo $key ?>]"  id="cookiecontrol_settings[languageCode][<?php echo $key ?>]" value="<?php echo $val ?>" size="20" />
                                        <a href="#" id="removeExtraLanguage">Remove</a>
                                    </td>
                                </tr>
                            </table>
                        </div>		
                    <?php } ?>
                <?php } 
        ?>
      </div>
      <div class="extraTranslation">
      <table class="form-table">
        <tr valign="top">
          <td>
            <label for="cookiecontrol_settings[translations]">Add your translations here</label>		
            <p>The translation can accept all of the t objects.</p>					
          </td>
        </tr>
        <tr valign="top">
          <td>
            <textarea name="cookiecontrol_settings[translations]" id="cookiecontrol_settings[translations]" cols="70" rows="10"><?php echo $options['translations'] ?></textarea>
          </td>
          <td>
            <p>Your input should contain all of the language strings you wish to translate. For instance, if you specified 'en', and 'fr' as locales, your input will be: </p>
            <pre  style="font-size: 10px;">
locale_t : {
	en: {
		title: 'lorem ipsum',
		intro: 'lorem ipsum...',
		full:'lorem ipsum...'
	},
	fr: {
		title: 'lorem ipsum',
		intro: 'lorem ipsum...',
		full:'lorem ipsum...'
	}    
}
            </pre>	
          </td>
        </tr>
      </table>
    </div>	
	
    <hr />
    </div>
  </div>
  
    <!-- Submit -->
    <p class="submit">
      <input type="submit" class="button-primary" value="<?php _e('Save Settings') ?>" />
    </p>
</form>
<!-- The Reset Option -->
<form method="post" action="options.php">
    <?php settings_fields('cookiecontrol_settings'); ?>
    <?php global $cookiecontrol_defaults; // use the defaults ?>
    <?php foreach((array)$cookiecontrol_defaults as $key => $value) : ?>
    <input type="hidden" name="cookiecontrol_settings[<?php echo $key; ?>]" value="<?php echo $value; ?>" />
    <?php endforeach; ?>
    <input type="hidden" name="cookiecontrol_settings[update]" value="RESET" />
    <input type="submit" class="button" value="<?php _e('Reset Settings') ?>" />
</form>
<!-- End Reset Option -->

</div>
</div><!-- End of Plugin Option Page Container -->

<?php 
}

function cookiecontrol_settings_update_check() {
    global $cookiecontrol_settings;
    if(isset($cookiecontrol_settings['update'])) {
	echo '<div class="updated fade" id="message"><p>Cookie Control Settings <strong>'.$cookiecontrol_settings['update'].'</strong></p></div>';
	unset($cookiecontrol_settings['update']);
	update_option('cookiecontrol_settings', $cookiecontrol_settings);
    }
}

function cookiecontrol_settings_validate($input) {
    $input['text'] = sanitize_text_field(wp_filter_nohtml_kses($input['text']));
    $input['position'] = wp_filter_nohtml_kses($input['position']);
    $input['shape'] = wp_filter_nohtml_kses($input['shape']);
    $input['timeout'] = intval($input['timeout']);
    $input['countries'] = wp_filter_nohtml_kses($input['countries']);
    $input['analytics'] = strip_tags($input['analytics']); //wp_filter_nohtml_kses($input['analytics']);

    $input['ias'] = sanitize_text_field(wp_filter_nohtml_kses($input['ias']));
    $input['on'] = sanitize_text_field(wp_filter_nohtml_kses($input['on']));
    $input['off'] = sanitize_text_field(wp_filter_nohtml_kses($input['off']));
    $input['bs'] = sanitize_text_field(wp_filter_nohtml_kses($input['bs']));
    $input['rm'] = sanitize_text_field(wp_filter_nohtml_kses($input['rm']));
    $input['rl'] = sanitize_text_field(wp_filter_nohtml_kses($input['rl']));
    $input['ab'] = sanitize_text_field(wp_filter_nohtml_kses($input['ab']));
    $input['c'] = sanitize_text_field(wp_filter_nohtml_kses($input['c']));
	
    $input['brandingColor'] = (empty($input['brandingColor']) || !preg_match('|^#([A-Fa-f0-9]{3}){1,2}$|', $input['brandingColor'])) ? '' : $input['brandingColor'];
    $input['buttonsColor'] = (empty($input['buttonsColor']) || !preg_match('|^#([A-Fa-f0-9]{3}){1,2}$|', $input['buttonsColor'])) ? '' : $input['buttonsColor'];
    $input['buttonsHoverColor'] = (empty($input['buttonsHoverColor']) || !preg_match('|^#([A-Fa-f0-9]{3}){1,2}$|', $input['buttonsHoverColor'])) ? '' : $input['buttonsHoverColor'];
    $input['linksColor'] = (empty($input['linksColor']) || !preg_match('|^#([A-Fa-f0-9]{3}){1,2}$|', $input['linksColor'])) ? '' : $input['linksColor'];
    $input['textColor'] = (empty($input['textColor']) || !preg_match('|^#([A-Fa-f0-9]{3}){1,2}$|', $input['textColor'])) ? '' : $input['textColor'];
    $input['barColor'] = (empty($input['barColor']) || !preg_match('|^#([A-Fa-f0-9]{3}){1,2}$|', $input['barColor'])) ? '' : $input['barColor'];

    $input['barHeight'] = (empty($input['barHeight']) || !is_numeric($input['barHeight'])) ? '50' : $input['barHeight'];
    $input['toggleWidth'] = (empty($input['toggleWidth']) || !is_numeric($input['toggleWidth'])) ? '' : $input['toggleWidth'];

    return $input;
}

add_action('wp_print_scripts', 'cookiecontrol_scripts');
function cookiecontrol_scripts() {
    if(!is_admin()) {
        wp_enqueue_script('cookiecontrol', WP_CONTENT_URL.'/plugins/cookie-control/js/cookieControl-7.2.min.js', array('jquery'), '', true);
    }
}

add_action('wp_footer', 'cookiecontrol_args', 1500);
function cookiecontrol_args() {
	global $cookiecontrol_settings; 
  	$cookiecontrol_timeout = $cookiecontrol_settings['timeout'] * 1000; // Convert seconds to microseconds
  	$privacy = ($cookiecontrol_settings['privacyURL'] != '')?sanitize_text_field($cookiecontrol_settings['privacyURL']):'';
	?>

<script type="text/javascript">
//<![CDATA[

cookieControl({

t: {
    title: '<p><?php echo sanitize_text_field(esc_html($cookiecontrol_settings['titleText'])); ?></p>',
    intro: '<p><?php echo sanitize_text_field(esc_html($cookiecontrol_settings['introText'])); ?></p>',
    full: '<p><?php echo sanitize_text_field(esc_html($cookiecontrol_settings['fullText'])); ?></p><p>Read more about our <a href="<?php echo $cookiecontrol_settings['privacyURL']; ?>" title="Read our privacy policy">privacy policy.</a></p>',
    
    ias: '<?php echo $cookiecontrol_settings['ias']; ?>',
    on: '<?php echo $cookiecontrol_settings['on']; ?>',
    off: '<?php echo $cookiecontrol_settings['off']; ?>',
    bs: '<?php echo $cookiecontrol_settings['bs']; ?>',
    rm: '<?php echo $cookiecontrol_settings['rm']; ?>',
    rl: '<?php echo $cookiecontrol_settings['rl']; ?>',
    ab: '<?php echo $cookiecontrol_settings['ab']; ?>',
    c: '<?php echo $cookiecontrol_settings['c']; ?>'
    },

<?php if ( sizeof($cookiecontrol_settings['languageCode']) > 0 && !empty($cookiecontrol_settings['languageCode']) && trim($cookiecontrol_settings['translations']) != '' ) { ?>
locale: [<?php foreach ( $cookiecontrol_settings['languageCode'] as $key => $val ) {  echo "'".sanitize_text_field($val)."',"; } ?> ],
<?php echo $cookiecontrol_settings['translations']; ?>,			
<?php } ?>

position:CookieControl.POS_<?php echo $cookiecontrol_settings['position']; ?>,
style:CookieControl.STYLE_<?php echo $cookiecontrol_settings['shape']; ?>,
theme:CookieControl.THEME_<?php echo $cookiecontrol_settings['theme']; ?>,

branding: <?php echo $cookiecontrol_settings['branding']; ?>,
hex: {
        branding: '<?php echo $cookiecontrol_settings['brandingColor']; ?>',
        buttons: '<?php echo $cookiecontrol_settings['buttonsColor']; ?>',
        buttonsHover: '<?php echo $cookiecontrol_settings['buttonsHoverColor']; ?>',
        links: '<?php echo $cookiecontrol_settings['linksColor']; ?>',
        text: '<?php echo $cookiecontrol_settings['textColor']; ?>',
        bar: '<?php echo $cookiecontrol_settings['barColor']; ?>'
      },

<?php if (!empty($cookiecontrol_settings['toggleWidth']) && trim($cookiecontrol_settings['toggleWidth']) != '' ) { ?>
toggleWidth: <?php echo $cookiecontrol_settings['toggleWidth']; ?>,
<?php } ?>

barHeight: <?php echo $cookiecontrol_settings['barHeight']; ?>,
toggleOnBar: <?php echo $cookiecontrol_settings['toggleOnBar']; ?>,
fullTextOnlyOnPopup: <?php echo $cookiecontrol_settings['fullTextOnlyOnPopup']; ?>,

startOpen: <?php echo $cookiecontrol_settings['popup']; ?>,
autoHide: <?php echo $cookiecontrol_timeout; ?>,
onlyHideIfConsented: <?php echo $cookiecontrol_settings['onlyHideIfConsented']; ?>,
alwaysShow: <?php echo $cookiecontrol_settings['alwaysShow']; ?>,
preserveConsentOnHide: <?php echo $cookiecontrol_settings['preserveConsentOnHide']; ?>,

subdomains: <?php echo $cookiecontrol_settings['subdomains']; ?>,
protectedCookies: [<?php echo $cookiecontrol_settings['protected']; ?>],

apiKey: '<?php echo $cookiecontrol_settings['apiKey']; ?>',
product: CookieControl.<?php echo $cookiecontrol_settings['product']; ?>,

<?php if ( $cookiecontrol_settings['product'] == 'PROD_PAID' ){ ?>
consentModel: {
                <?php if ( sizeof($cookiecontrol_settings['countryConsent']) > 0 && !empty($cookiecontrol_settings['countryConsent']) ) { ?>
                    <?php 
                        foreach ( $cookiecontrol_settings['countryConsent'] as $key => $val ) {                          
                            if ($cookiecontrol_settings['countryConsentModel'][$key] != "" && $cookiecontrol_settings['countryConsentModel'][$key] != "") { ?>
                                <?php echo "'".strtoupper(sanitize_text_field($val))."'"; ?>: CookieControl.MODEL_<?php echo $cookiecontrol_settings['countryConsentModel'][$key]; ?>,                             
                    <?php   }
                        } 
                    ?> 
                <?php } ?>
                'default':CookieControl.MODEL_<?php echo $cookiecontrol_settings['consentmodel']; ?>
		},
<?php } else { ?>
consentModel:  CookieControl.MODEL_<?php echo $cookiecontrol_settings['consentmodel']; ?>,
<?php } ?>  
onAccept:function(){ccAnalytics()},
onReady:function(){},
onCookiesAllowed:function(){ccAnalytics()},
onCookiesNotAllowed:function(){},
countries:'<?php echo $cookiecontrol_settings['countries']; ?>'

});
    

function ccAnalytics() {
    <?php echo $cookiecontrol_settings['analytics']; ?>
}
//]]>

</script>
<?php }
